# Reference: https://www.exclamationlabs.com/blog/continuous-deployment-to-npm-using-gitlab-ci/

# GitLab uses docker in the background, so we need to specify the
# image versions. This is useful because we're freely to use
# multiple node versions to work with it. They come from the docker
# repo.
# Uses NodeJS
image: node:latest

# And to cache them as well.
cache:
  paths:
    - node_modules/

# We tell GitLab to install all the packages
# before running anything.
# Docker images come with yarn preinstalled
before_script:
  - apt-get update -qq && apt-get install

variables:
  DATABASE_URL: $DATABASE_URL
  DATABASE_TEST_URL: $DATABASE_URL
  PORT: $CI_PORT
  DB_TEST_NAME: $CI_DATABASE_URL
  JWT_SECRET: $CI_JWT_SECRET
  FILES_FOLDER: $CI_FILES_FOLDER

# You specify the stages. Those are the steps that GitLab will go through
# Order matters.
stages:
  - build
  - unit_tests
  # - e2e_tests
      
Build:
  stage: build
  # tags:
  #   - node
  before_script: 
    - echo "DATABASE_URL"=$DATABASE_URL >> ".env"
    - echo "DATABASE_TEST_URL"=$DATABASE_URL >> ".env"
    - echo "DB_TEST_NAME"=$DB_TEST_NAME >> ".env"
    - echo "JWT_SECRET"=$JWT_SECRET >> ".env"
    - echo "PORT"=$PORT >> ".env"
    - cat .env
    - npm install
  script:
    - npm run build

Unit testing:
  stage: unit_tests
  script:
    # Runs the tests.
    - npm run test

# End to End testing:
#   stage: e2e_tests
#   script:
#     - npm run test:e2e
